// Transformacoes2.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include <stdio.h>
#include <GL\gl.h>
#include <GL\glut.h>


struct Modelo_s
{
	float eyex, eyey, eyez;
	int anima_sleep;
	GLboolean usePushPopMatrix;
	GLfloat angCubo1;
	GLfloat angCubo2;
} modelo;

void escreve(char texto[], GLfloat x, GLfloat y, GLfloat orient, GLfloat largura, GLfloat altura, GLint modo)
{
	GLint i, n, comprimento = 0;

	n = strlen(texto);
	for (i = 0; i < n; i++)
		comprimento += glutStrokeWidth(GLUT_STROKE_ROMAN, texto[i]);
	glPushMatrix();
		glTranslatef(x, y, 0.0);
		glRotatef(orient, 0.0, 0.0, 1.0);
		glScalef(largura, altura, 1.0);
		if (modo == 0) // alinha 'a esquerda
			; // nada a fazer
		else if (modo == 1) // alinha ao centro
			glTranslatef(-(GLfloat) comprimento / 2.0, 0.0, 0.0);
		else // alinha 'a direita
			glTranslatef(-(GLfloat) comprimento, 0.0, 0.0);
		for (i = 0; i < n; i++) {
			glutStrokeCharacter(GLUT_STROKE_ROMAN, texto[i]);
		}
	glPopMatrix();
}

void drawString(GLfloat x, GLfloat y, GLfloat z, GLfloat scale, char* msg)
{
  glPushMatrix();
	glTranslatef(x, y, z);
	glScalef(scale, scale, scale);
	for (int i = 0; i < strlen(msg); i++)
		glutStrokeCharacter(GLUT_STROKE_ROMAN, msg[i]);
  glPopMatrix();
}

void drawAxis()
{
#define AXIS_LIMIT	3

	GLfloat mat_r[] = {1.0, 0.0, 0.0, 1.0};
	GLfloat mat_g[] = {0.0, 1.0, 0.0, 1.0};
	GLfloat mat_b[] = {0.0, 0.0, 1.0, 1.0};
	GLfloat mat_w[] = {1.0, 1.0, 1.0, 1.0};

	glPushAttrib(GL_LINE_BIT);
	glLineWidth(2.0);
	glBegin(GL_LINES);
		// XX
		glColor4fv(mat_r);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_r);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(-AXIS_LIMIT, 0, 0);
		glVertex3f(+AXIS_LIMIT, 0, 0);


		// YY
		glColor4fv(mat_g);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_g);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(0, -AXIS_LIMIT, 0);
		glVertex3f(0, +AXIS_LIMIT, 0);

		// ZZ
		glColor4fv(mat_b);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_b);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(0, 0, -AXIS_LIMIT);
		glVertex3f(0, 0, +AXIS_LIMIT);
	glEnd();
	glPopAttrib();

	//axis' names
	glColor4fv(mat_w);
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_w);
	drawString(+AXIS_LIMIT, 0, 0, 0.002, "X");
	drawString(0, +AXIS_LIMIT, 0, 0.002, "Y");
	drawString(0, 0, +AXIS_LIMIT, 0.002, "Z");
}

void display()
{
	GLfloat mat_w[] = {1.0, 1.0, 1.0, 1.0};
	GLfloat mat_obj1[] = {0.6, 0.6, 0.6, 1.0};
	GLfloat mat_obj2[] = {0.0, 0.5, 1.0, 1.0};

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(modelo.eyex, modelo.eyey, modelo.eyez, 
			0.0, 0.0, 0.0, 
			0.0, 1.0, 0.0
			);

	//glTranslatef(0, 0, -5);
	//gluLookAt(0, 0, 5, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

	// eixo global
	drawAxis();

	// desenhar modelo

	// 1 cubo a rodar sobre origem
	if (modelo.usePushPopMatrix)
		glPushMatrix();
		
		glRotatef(modelo.angCubo1, 0, 0, 1);
		glTranslatef(1, 0, 0);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mat_obj1);
		glutSolidCube(0.5);
	
	if (modelo.usePushPopMatrix)
		glPopMatrix();

	glTranslatef(1.5, 1.5, 0);

	// 2 cubo a rodar sobre ele proprio
	if (modelo.usePushPopMatrix)
		glPushMatrix();
		
		glRotatef(modelo.angCubo2, 0, 1, 0);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mat_obj2);
		glutSolidCube(0.5);

	if (modelo.usePushPopMatrix)
		glPopMatrix();

	// output message
	char * msg;
	if (modelo.usePushPopMatrix)
		msg = "usando push/pop";
	else
		msg = "sem push/pop";
	glPushMatrix();
		glLoadIdentity();
		gluLookAt(0, 0, 5, 0, 0, 0, 0, 1, 0);
		
		glColor4fv(mat_w);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_w);
		drawString(-2, -2, 0, 0.002, msg);
	glPopMatrix();

	//glFlush ();
	glutSwapBuffers();
}

void reshape(int w, int h)
{
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//glOrtho(-3.0, 3.0, -3.0, 3.0, 0.1, 20.0);
	gluPerspective(45, 1, 1, 10);

	//glMatrixMode(GL_MODELVIEW);
	//glLoadIdentity();
	//gluLookAt(modelo.eyex, modelo.eyey, modelo.eyez, 
	//		0.0, 0.0, 0.0, 
	//		0.0, 1.0, 0.0
	//		);
}


void keyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
	case 27:
		exit(0);
		break;
	case ' ':
		modelo.angCubo1 = modelo.angCubo2 = 0;
		modelo.usePushPopMatrix = !modelo.usePushPopMatrix;
		break;
	case 'x':
		modelo.eyex -= 0.1;
		break;
	case 'X':
		modelo.eyex += 0.1;
		break;
	case 'y':
		modelo.eyey -=0.1;
		break;
	case 'Y':
		modelo.eyey += 0.1;
		break;
	case 'z':
		modelo.eyez -=0.1;
		break;
	case 'Z':
		modelo.eyez += 0.1;
		break;
	case 'o':
	case 'O':
		modelo.eyex = modelo.eyey = 0;
		modelo.eyez = 5;
		break;
	case 'r':
	case 'R':
		modelo.eyex = 1.69;
		modelo.eyey = 2.9;
		modelo.eyez = 8.1;
		break;
	}
	printf("Camera: %f, %f, %f\n", modelo.eyex, modelo.eyey, modelo.eyez);
	glutPostRedisplay();
}

void init()
{
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);

  modelo.angCubo1 = modelo.angCubo2 = 0;
  modelo.usePushPopMatrix = GL_TRUE;
  modelo.anima_sleep = 100;
  modelo.eyex = 1.69;
  modelo.eyey = 2.9;
  modelo.eyez = 8.1;
}

void anima(int v)
{
	glutTimerFunc(modelo.anima_sleep, anima, 0);

	modelo.angCubo1 += 5;
	if (modelo.angCubo1 > 360)
		modelo.angCubo1 = 0;
	modelo.angCubo2 += 5;
	if (modelo.angCubo2 > 360)
		modelo.angCubo2 = 0;

	glutPostRedisplay();
}

int main(int argc, CHAR* argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(500, 500);
	glutInitWindowPosition (100, 100);
	glutCreateWindow("Transformacoes #2");
	init ();
	glutKeyboardFunc(keyboard);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutTimerFunc(modelo.anima_sleep, anima, 0);
	glutMainLoop();

	return 0;
}



